import path from 'path';
import os from 'os';
import fs from 'fs-extra';
import yaml from 'js-yaml';
import { getCredential } from '@serverless-devs/core';


function getSecretValue(n: number, str = ' ') {
    let temp_str = '';
    for (let i = 0; i < n; i++) {
        temp_str = temp_str + str;
    }
    return temp_str;
}

export default class GetAccess {
    async get(aliasName?: string) {
        const accessFile = path.join(os.homedir(), '.s', 'access.yaml');
        if(!fs.existsSync(accessFile)) {
            fs.ensureFileSync(accessFile);
        }
        const accessFileInfo = yaml.load(fs.readFileSync(accessFile, 'utf8') || "{}");
        const accessInfo = {}
        for (const eveAccess in accessFileInfo) {
            const tempAccess = await getCredential(eveAccess)
            const tempAlias = tempAccess['Alias']
            const tempSecretAccess = {}
            for (const eveValue in tempAccess) {
                if (eveValue != 'Alias') {
                    const valueLength: any = tempAccess[eveValue].length;
                    tempSecretAccess[eveValue] = valueLength > 6 ? tempAccess[eveValue].slice(0, 3) + getSecretValue(valueLength - 6, '*') + tempAccess[eveValue].slice(valueLength - 3, valueLength) : tempAccess[eveValue];
                }
            }
            accessInfo[tempAlias] = tempSecretAccess
        }
        
        return { originAccessInfo: accessFileInfo, confusedAccessInfo: accessInfo };
    }
}
